setlocal ts=2 sw=2 expandtab omnifunc=necoghc#omnifunc

"set background=light
"set guifont=Neep\ Medium\ Semi-Condensed\ 18

let g:haskell_classic_highlighting = 1


syntax on
filetype plugin indent on


call CmdAlias('hasktags', '!/home/jule/.cabal/bin/hasktags -c .<CR>')



function! HaskellDocCurrentWord()
        let word = expand("<cword>")
        exe "IDoc " . word
endfunction



nmap <F8> :call HaskellDocCurrentWord()<CR><CR>

nmap <silent> <F3> :silent update <bar> HsimportModule<CR>
nmap <silent> <F4> :silent update <bar> HsimportSymbol<CR>

" haskell-vim

" let g:haskell_enable_quantification = 1
" let g:haskell_enable_recursivedo = 1
" let g:haskell_enable_arrowsyntax = 1
" let g:haskell_enable_pattern_synonyms = 1
" let g:haskell_enable_typeroles = 1

" let g:haskell_indent_if = 3
" let g:haskell_indent_case = 5
" let g:haskell_indent_let = 4
" let g:haskell_indent_where = 6
" let g:haskell_indent_do = 3
" let g:haskell_indent_in = 1


" liquid-types
let g:vim_annotations_offset = '/.liquid/'


" autocmd BufWritePost *.hs call s:check_and_lint()
" function! s:check_and_lint()
  " let l:path = expand('%:p')
  " let l:qflist = ghcmod#make('check', l:path)
  " call extend(l:qflist, ghcmod#make('lint', l:path))
  " call setqflist(l:qflist)
  " cwindow
  " if empty(l:qflist)
    " echo "No errors found"
  " endif
" endfunction


" let g:deoplete#enable_at_startup = 1

" set hidden

" let g:LanguageClient_serverCommands = {
	" \ 'haskell': ['hie', '--lsp', '-d', '-l', '/home/hasufell/lang-server.log'],
	" \ }

" nnoremap <silent> K :call LanguageClient#textDocument_hover()<CR>
" nnoremap <silent> gd :call LanguageClient#textDocument_definition()<CR>
" nnoremap <silent> <F2> :call LanguageClient#textDocument_rename()<CR>

" autocmd VimEnter * LanguageClientStart

if has("nvim")
	let g:ale_enabled = 0

	" let g:intero_backend = {
			" \ 'command': 'cabal new-repl',
			" \ 'options': '',
			" \ 'cwd': expand('%:p:h'),
			" \}

	" Intero starts automatically. Set this if you'd like to prevent that.
	let g:intero_start_immediately = 1

	" Enable type information on hover (when holding cursor at point for ~1 second).
	let g:intero_type_on_hover = 1

	" Change the intero window size; default is 10.
	let g:intero_window_size = 15

	" Sets the intero window to split vertically; default is horizontal
	let g:intero_vertical_split = 1

	" OPTIONAL: Make the update time shorter, so the type info will trigger faster.
	set updatetime=1000

	map <silent> <leader>t <Plug>InteroGenericType
else
	let g:ghcmod_hlint_options = ['--ignore=Eta reduce $']

	" ALE
	let g:ale_linters = {'haskell':['ghc-mod', 'hdevtools'], 'c':['clang']}
	" let g:ale_fixers = {
		" \    'go': ['gofmt', 'goimports'],
		" \}
	let g:ale_haskell_hdevtools_options = "-g '-Wall' -g '-Wno-orphans'"

	" neco-ghc
	let g:necoghc_enable_detailed_browse = 1
	let g:haskellmode_completion_ghc = 0
	let g:necoghc_enable_detailed_browse = 1
	autocmd FileType haskell setlocal omnifunc=necoghc#omnifunc
	let g:ycm_semantic_triggers = {'haskell' : ['.']}

	" clear search
	nmap <F2> :noh<CR>:GhcModTypeClear<CR>
	imap <F2> <C-O>:noh<CR>:GhcModTypeClear<CR>

	" unmap <F3>
	" unmap <F4>

	nmap <F6> :GhcModType<CR>
endif
